# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from carla_msgs/CarlaWalkerControl.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class CarlaWalkerControl(genpy.Message):
  _md5sum = "bd3de0306de3de4e7161a29868c1f9a7"
  _type = "carla_msgs/CarlaWalkerControl"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """#
# Copyright (c) 2019 Intel Corporation.
#
# This work is licensed under the terms of the MIT license.
# For a copy, see <https://opensource.org/licenses/MIT>.
#
# This represents a walker control message sent to CARLA simulator

geometry_msgs/Vector3 direction
float32 speed
bool jump

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['direction','speed','jump']
  _slot_types = ['geometry_msgs/Vector3','float32','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       direction,speed,jump

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CarlaWalkerControl, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.direction is None:
        self.direction = geometry_msgs.msg.Vector3()
      if self.speed is None:
        self.speed = 0.
      if self.jump is None:
        self.jump = False
    else:
      self.direction = geometry_msgs.msg.Vector3()
      self.speed = 0.
      self.jump = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3dfB().pack(_x.direction.x, _x.direction.y, _x.direction.z, _x.speed, _x.jump))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.direction is None:
        self.direction = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 29
      (_x.direction.x, _x.direction.y, _x.direction.z, _x.speed, _x.jump,) = _get_struct_3dfB().unpack(str[start:end])
      self.jump = bool(self.jump)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3dfB().pack(_x.direction.x, _x.direction.y, _x.direction.z, _x.speed, _x.jump))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.direction is None:
        self.direction = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 29
      (_x.direction.x, _x.direction.y, _x.direction.z, _x.speed, _x.jump,) = _get_struct_3dfB().unpack(str[start:end])
      self.jump = bool(self.jump)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3dfB = None
def _get_struct_3dfB():
    global _struct_3dfB
    if _struct_3dfB is None:
        _struct_3dfB = struct.Struct("<3dfB")
    return _struct_3dfB
